#include "stdafx.h"
 
#include "cpss_dialog.h"
#include <stdio.h>
#include "Tanks.h"

 
 
#define  HEIGHT_BUTTON_WIDTH 80
 
 typedef struct __CellTitle{
	UINT nID; // str ID , -1 is direct string
	char  pstr[16]; // used when nID==-1
	RECT rt;
	//CMyBitmap* placehold[3];
}  TITLE_CELL;
 
 typedef struct {
	UINT nID; // str ID , -1 is direct string
	char  pstr[16]; // used when nID==-1
	RECT rt;
	CMyBitmap placehold[3];
}  DISPLAY_CELL;


 #define m_btnlist m_Btns
 #define m_btAct (&m_Btns[1])


#define yStart 50

static const TITLE_CELL gTitle[]={ {IDS_TANK_DATUM,{0},{40,yStart,122,ROW_H} },{IDS_TANK_START,{0},{182,yStart,122,ROW_H} },
{IDS_TANK_KM_STAND,{0},{314,yStart,122,ROW_H} },{IDS_TANK_LKM,{0},{462,yStart,90,ROW_H}},{IDS_TANK_ENDE,{0},{562,yStart,122,ROW_H} } };

 
static DISPLAY_CELL   display_cell [5]=																				   
	{{10,{0},{40,120,121,ROW_H} },	{10,{0},{182,120 ,111 ,ROW_H} },{10,{0},{314,120,126,ROW_H}},{10,{0},{461,120,81,ROW_H}},{10,{0},{563,120,111,ROW_H}} } ;
//	{{10,{0},{40,196,122,ROW_H}},	{10,{0},{182,196 ,112 ,ROW_H}},{10,{0},{314,196,126,ROW_H}},{10,{0},{462,196,82,ROW_H}},{10,{0},{562,196,112,ROW_H}} },
//	{{10,{0},{40,276,122,ROW_H}},	{10,{0},{182,276 ,112 ,ROW_H}},{10,{0},{314,276,126,ROW_H}},{10,{0},{462,276,82,ROW_H}},{10,{0},{562,276,112,ROW_H}} } 

static const  int tankBmpId[5] ={IDB_PLACE_DATUM , IDB_PLACE_TANK , IDB_PLACE_KM , IDB_PLACE_1KM, IDB_PLACE_TANK}; 
static HWND g_hWnd=NULL;
CSimpleArray<unsigned char*> g_dataPool;
void tank_callback(unsigned char* buf,HWND hWnd)
{
	if(buf==NULL) return;
	unsigned char* data = new unsigned char[20];
	memcpy(data,buf,19);
	g_dataPool.Add( data);
	if(g_hWnd!=NULL && IsWindow(g_hWnd))
	{
		InvalidateRect(g_hWnd,NULL,TRUE);
		UpdateWindow(g_hWnd);
	}
}
#define BORD_TANK_DATA_NAME  BORD_PRIVATE_DIR##"\\tanks.dat"
void save_tank_data()
{
	FILE *f = fopen(BORD_TANK_DATA_NAME,"wt");
	if(f)
	{
		char*p, line[64];
		int count = g_dataPool.GetSize();
		for(int i=0;i<count;i++)
		{
			unsigned char* data = g_dataPool[i];
			
			for(int i=0;i<19;i++)
			{
				fprintf(f,"%02x" , (unsigned)(data[i]&0xff) ) ;
			}
			fprintf(f,"\n") ;	
			delete data;
		}

		fclose(f);
		//g_dataPool.RemoveAll();
	}
}


void load_tank_data()
{
	FILE* f = fopen(BORD_TANK_DATA_NAME,"rt");
	if(f)
	{
		char*p, line[64];
		
		while( p = fgets(line,63, f) )
		{
			int l = strlen(p);
			if(l<19*2) break;
			unsigned char* data = new unsigned char[20];
			for(int i=0;i<19;i++)
			{
				data[i] = hex_to_val(*p++)<<4  ;
				data[i] += hex_to_val(*p++) ;
			}
			g_dataPool.Add( data);
		}

		fclose(f);
	}
}
static void parse_data(unsigned char* buf)
{
	DWORD dw;
	if(4 ==buf[0])
	{
		if(buf[1]==1) {
			char unit[4];
			if(buf[15]==0) strcpy(unit,"%");
			else strcpy(unit,"L");

			if(LongInvalid((&buf[11]))) strcpy(display_cell[0].pstr,"---");
			else{
				BY2DW(dw,&buf[11]);
				sprintf(display_cell[0].pstr,"%02d.%02d.%02d", buf[2], buf[3], buf[4]);
			}
			if(ShortInvalid((&buf[5]))) strcpy(display_cell[1].pstr,"---");
			else{
				BY2HW(dw,&buf[5]);
				sprintf(display_cell[1].pstr,"%.1f %s", dw*0.1 ,unit); //Tankfllstand Start
			}
			if(LongInvalid((&buf[9]))) strcpy(display_cell[2].pstr,"---");
			else{
				BY2DW(dw,&buf[9]);
				sprintf(display_cell[2].pstr,"%.1f",  (dw*0.005));
			}
			if(ShortInvalid((&buf[13]))) strcpy(display_cell[3].pstr,"---");
			else{
				BY2HW(dw,&buf[13]);//dw= ((buf[13]&0xff)<<8 + (buf[14]&0xff) ); //
				sprintf(display_cell[3].pstr,"%.2f",  dw*0.01);
			}
			if(ShortInvalid((&buf[7]))) strcpy(display_cell[4].pstr,"---");
			else{
				BY2HW(dw,&buf[7]);
				sprintf(display_cell[4].pstr,"%.1f %s", dw*0.01,unit); //Tankfllstand Ende
			}
		} 
	} 
}


static const BUTTON_ITEM Button_EngInfo[] = 
{
 
	{ Btn_CancelX, Btn_CancelY,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN}

};

static const BUTTON_ITEMEX Button1_EngInfo[] = 
{
 
	{ 560 , 370,	HEIGHT_BUTTON_WIDTH , 43,ID_BUTTON_RESET,IDB_BDCOMP_BUTTON_RESET , IDB_BDCOMP_BUTTON_RESET_DN,   0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL} 
	 
};
static const SCROLL_ITEM mScreelInfoMsgView={DEF_SCROLL_RECT,NULL,0,0,73,44,
                          IDB_ADDRSCOLL_BT_UP,IDB_ADDRSCOLL_BT_UP_DN,IDB_ADDRSCOLL_BT_DW,IDB_ADDRSCOLL_BT_DW_DN};

LRESULT TankStatic::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 
	for(int i=0; i<sizeof(Button_EngInfo)/sizeof(BUTTON_ITEM) ; i++)
	{
		CREATE_BTN_TRANS2(m_btnlist[i], m_nIDBACK, Button_EngInfo[i]);
	}

	RECT rect;
	rect = Button1_EngInfo[0].rt;
	
	 
	for(int i=0; i<sizeof(Button1_EngInfo)/sizeof(BUTTON_ITEMEX) ; i++)
	{
		BOOL bEnable = true;
		
		CString str;
		str.LoadString(Button1_EngInfo[i].uId );
		CREATE_BTN_TRANS(m_btAct[i], m_nIDBACK,str,Button1_EngInfo[i]);
		
	}
 
		

//	DWORD dwID;
//	ghExitEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
//	g_hCommandThread = CreateThread(NULL,0 , CommandTask ,(void*)m_hWnd,0, &dwID);
	m_count = g_dataPool.GetSize();
g_hWnd = m_hWnd;
//	OnButton2(0,0,0, bHandled);
		cScrollBar.CreateWnd(m_hWnd,IDB_LISTSCOLL_BK,m_nIDBACK,&mScreelInfoMsgView,0);
	m_pScrollbar=&cScrollBar;
    EnableScrollBtn(0);
	SetTimer(1,5000,NULL);
	VButtonWnd::OnInitDialog(uMsg, wParam, lParam, bHandled) ;
    return 0;  
}


 
void TankStatic::OnPaintExt(HDC hDC,CRect& rcPaint)
{
	DrawDC Draw(hDC);
	CCanvas canvas(hDC);
	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(255, 255, 255));
	CRect rect;
	HFONT hOldFont = Draw.SetFont(m_hBigFont);
	CString str;
	int cols = sizeof(gTitle)/sizeof(TITLE_CELL);
	int k,j=0;
	for(int i=0;i<cols;i++)
	{
		str.LoadString(gTitle[i].nID);
		rect.left= gTitle[i].rt.left;rect.top=  gTitle[i].rt.top;
		rect.right= rect.left+gTitle[i].rt.right;rect.bottom= rect.top+gTitle[i].rt.bottom;

		int style = DT_BOTTOM|DT_CENTER;
		//if(str.Find('\n')!=-1) style = DT_BOTTOM|DT_WORDBREAK;
		int n  = str.Find('\n') ;
		if(n!=-1)
		{
			CString str1 = str.Left(n);
			CRect rc(rect);
			rc.OffsetRect(0,-20);
			Draw.DrawStringRect((LPTSTR)(LPCTSTR)str1,&rc,style);
			str = str.Right(str.GetLength()- n-1 );
		}
		Draw.DrawStringRect((LPTSTR)(LPCTSTR)str,&rect,style);
	}
	if(g_dataPool.GetSize()!=m_count)
	{
		m_count = g_dataPool.GetSize();
		EnableScrollBtn(0);

	}
	int line = 0;
	for(k=m_off;k<3+m_off;k++)
	{
		
		for(j=0;j<cols;j++){
			if(k<g_dataPool.GetSize()){
				parse_data( g_dataPool[k]);
			}else {
				for(int m=0;m<sizeof(display_cell)/sizeof(DISPLAY_CELL);m++)
				{
					display_cell [m].pstr[0]=0;
				}	
			}

			rect.left= display_cell[j].rt.left;rect.top= display_cell[j].rt.top + line*(ROW_H+ 18 );
			rect.right= rect.left+display_cell[j].rt.right;rect.bottom= rect.top+display_cell[j].rt.bottom;
			 
			//Draw.DrawNewRect2(&rect,TRUE,TRUE,FILL_CLR); 
			draw_placeholder(display_cell[j].placehold[k-m_off],tankBmpId[j]);
			/*if(display_cell[j].placehold[i].m_hBitmap==NULL)
			{
				display_cell[j].placehold[i].LoadBitmap(tankBmpId[j],m_nIDBACK,rect.left,rect.top);
			}
			canvas.BitBlt(display_cell[j].placehold[i],rect.left,rect.top,TRUE);*/
			if(k<g_dataPool.GetSize()) 
				Draw.DrawStringRect(convert_val(display_cell[j].pstr) ,&rect,DT_CENTER|DT_VCENTER);
			
		}
		line++;
		//if(i-m_off >=2 ) break;
	}

	
	Draw.SetFont(hOldFont);
	 
}
 
LRESULT TankStatic::OnReset(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	if(IDOK==AlertBox(IDS_BORD_RESET_MSG,2))
	{
		for(int j=0;j<sizeof(display_cell)/sizeof(DISPLAY_CELL);j++)
		{
			display_cell [j].pstr[0]=0;
		}		 
		
		int count = g_dataPool.GetSize();
		for(int i=0;i<count;i++)
		{
			unsigned char* data = g_dataPool[i];					 
			delete data;
		}
		g_dataPool.RemoveAll();
		Invalidate();
		UpdateWindow();
	 }
  return 0;
}
LRESULT TankStatic::OnButton2(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	 
  return 0;
}


LRESULT TankStatic::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
//	SetEvent(ghExitEvent);
//	if(	g_hCommandThread ) WaitForSingleObject(g_hCommandThread,TIMEOUT_COMMAND); g_hCommandThread=0;
//	__restore_pre_window_handle__(m_hWnd);
	g_hWnd = NULL;
//	CloseHandle(ghExitEvent);
	EndDialog(1);
	//PostQuitMessage(0);
	
	return 0;
}



LRESULT TankStatic::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	BOOL bHandled;
	//OnButton2(0,0,0, bHandled);
	return 0;
}






LRESULT TankStatic::OnUserIndicate(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 
/*	FILE * file;
	TCHAR tmpPath[64];
	char line[128],*retstr,*valptr,*buf=0;
	int num =0;
	sprintf(line, "%s\\boardcomp.dat" , DIAG_IN_PATH);
	mbstowcs(tmpPath,line ,strlen(line)+1);
	file = fopen(line,"r");
	if(file){

		fseek(file,0,SEEK_END);
		int len = ftell(file);
		buf = (char*)malloc(len+1);
		fseek(file,0,SEEK_SET);
		fread(buf,1,len,file);
		num=9;
		retstr  =strtok(buf," ") ;
		while( retstr )
		{
				valptr = get_val_ptr(num);
				if(valptr){
					strcpy(valptr,retstr);
				}
				retstr  =strtok(NULL," ") ;
				num++;
		}
		free(buf);
		fclose(file);
		DeleteFile(tmpPath);
		Invalidate(FALSE);
		UpdateWindow();
	}
	m_btAct[0].EnableWindow(TRUE);
*/
	return 0;
}

#define __MIN(x,y) (x>y)?y:x
LRESULT TankStatic::OnScroll(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	BOOL bUpdate = FALSE;
	if (wParam == 0)
	{
		if(m_off>0) 
		{
			m_off--;
			cScrollBar.UpEnable(m_off>0);
			cScrollBar.DownEnable( m_count-m_off>4);
			 bUpdate = TRUE;
			 
		}
	}else
	{
		if(m_off<m_count-4){
			m_off++;
			cScrollBar.DownEnable(m_count-m_off>4);
			cScrollBar.UpEnable(m_off>0);
			  bUpdate = TRUE;
		}
	}
	if(bUpdate)
	{
		Invalidate();
		UpdateWindow();
	}
	return 0;
}

void TankStatic::EnableScrollBtn(BOOL bErase)
{
	
	if( m_pScrollbar){
		 	
		m_pScrollbar->UpEnable(m_off>0,bErase);
		m_pScrollbar->DownEnable( m_off< m_count-3 ,bErase);
		 
	}
}

